from application_manager import LLMApplication
import logging
from IAIS_llm import llm
from langchain_core.output_parsers import StrOutputParser
from langchain_core.prompts import ChatPromptTemplate

# Configure logging
logging.basicConfig(level=logging.INFO, format="%(asctime)s - %(name)s - %(levelname)s - %(message)s")
logger = logging.getLogger(__name__)

print("{{ model_name }}")
class DirectLLMApplication(LLMApplication):
    def process_request(self, llm_query):
        logging.info("Processing request using DirectLLMApplication")
        
        if not hasattr(llm_query, "input") and llm_query.input.prompt:
            logging.info("Processing request from 'input.prompt'...")
            return {
                "status": "error",
                "message": "Invalid input. Please provide either 'input.prompt' or 'qa.question'."
            }

        try:
            output_parser = StrOutputParser()
            custom_prompt = ChatPromptTemplate.from_template(llm_query.input.prompt)

            # Create the LLMChain
            chain = custom_prompt | llm | output_parser
            response = chain.invoke({"topic": llm_query.input.context})

            print(response)
            return {
                "status": "success",
                "data":   response
                    
            }
        except Exception as e:
            logging.exception("Error during LLM invocation: %s", e)
            return {
                "status": "error",
                "message": "Failed to process request. Please try again later."
            }